/******************************************************/
/* Se espera a la recepcion de un comando de conexion */
/* o de emparejamiento ( +RCOI o +RCPI )              */
/******************************************************/

int BT_espera_conexion()
{
  int inByte;
  //Serial.println(" ");
  vacia_buffer_serial3();
  Serial.println("BT_espera_conexion  .........    => ");
                                                 // Si llega +RCOI=... es que es conexion...
                                                 // Si llega +RPCI=... es que se va a emparejar 
  while (Serial3.available()== 0) {}             // Esperar a que llegue un caracter
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != '+') 
    return -1;
      
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'R') 
    return -1;
    
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte); 

  switch (inByte) 
  {
  case 'C':
//***************************************************
//     confirmar que es +RCOI la respuesta...
//***************************************************
    while (!Serial3.available()) {}
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != 'O')
    return -1; 
    
    while (!Serial3.available()) {}
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != 'I') 
      return -1; 

    while (!Serial3.available()) {}
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != '=') 
      return -1;                                   // Ha llegado!! hay que leer y mostrar el resto de la linea
    delay(200);                                    // espera a que lleguen el resto de caracteres
    vacia_buffer_serial3();                        // se vacia e imprime el buffer
    BT_estado = 2;                                 // YA HAY CONEXION... se habilita para enviar el mensaje...
    Serial3.print("AT+JACR=1\r\n");               // Envia aceptacion
    wait_for_OK_timeout(2000);                    // Espera por respuesta OK
    break;
  case 'P':
//***************************************************
//     confirmar que es +RPCI= la respuesta...
//***************************************************
    while (!Serial3.available()) {}
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != 'C') 
      return -1; 
    
    while (!Serial3.available()) {}
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != 'I') 
      return -1; 

    while (!Serial3.available()) {} 
    inByte = Serial3.read();
    //Serial.write(inByte); 
    if (inByte != '=') 
      return -1;                                 // Ha llegado!! hay que emparejar...
    delay(200);                                  // espera a que lleguen el resto de caracteres
    vacia_buffer_serial3();                      // se vacia e imprime el buffer
    Serial3.print("AT+JPCR=04,8714\r\n");        // Envia pin 8714
    wait_for_OK();                               // Espera por respuesta OK
    wait_for_SecureLinlEstablished();            // Esperar por +RSLE cr lf
    delay(200);                                  // espera a que lleguen el resto de caracteres
    vacia_buffer_serial3();                      // se vacia e imprime el buffer
    return 1;                                    // se devuelve 1 para indicar que se ha emparejado correctamente
                                                 // se debe volver a llamar al mismo procedimiento para esperar por conexion...
    break;
  default: 
    return -1;                                   // devuelve error...
  } 
  delay(200);                                    // espera a que lleguen el resto de caracteres
  vacia_buffer_serial3();                        // se vacia e imprime el buffer
  return 0;                                      //  ha llegado bien ... esto es que se puede establecer conexion...
}

/**************************************************/
/* Se analizan los caracteres que se han recibido */
/* y se busca en ellos algun comando              */
/**************************************************/
int BT_analiza_secuencia_leida()
{
  char ristra1[64];                              // el buffer de entrada del arduino es del orden de 60 caracteres
                                                 // se crea espacio para descagarlo
  int contador=0, cont1=0;
  int inByte, hay_comando=0;
  //Serial.print(" ");
  while (Serial3.available()) 
  {                                              //Hay caracteres en el buffer de entrada... se van a leer y analizar
    inByte = Serial3.read();
    //Serial.write(inByte);                        // se imprime lo que se quita del buffer
    ristra1[contador]=inByte;
    if (inByte == '+') 
      hay_comando = 1;                           // se activa la marca de que hay almenos un "+"
    contador++; 
    delay(20);                                   // espera a que lleguen mas caracteres
  } 
  if (hay_comando == 0) 
    return 0;                                    // se anula la decodificacion por no haberse encontrado un "+"
  if (contador < 4) 
    return 0;                                    // se anula la decodificacion por no haber comando completo
  cont1=0;
  while (contador != 0) 
  {
    while (ristra1[cont1] != '+') 
    {                                            //nos saltamos los caracteres que precedan al caracter +
      //Serial.write (ristra1[cont1]); 
      contador--; 
      cont1++;
    }                                            // ahora a buscar la secuencia RDII
    if (ristra1[cont1] != '+') 
      return 0; 
    //Serial.write (ristra1[cont1]); 
    contador--; 
    cont1++;
    if (ristra1[cont1] != 'R') 
      return 0; 
    //Serial.write (ristra1[cont1]); 
    contador--; 
    cont1++;
    if (ristra1[cont1] != 'D') 
      return 0; 
    //Serial.write (ristra1[cont1]); 
    contador--; 
    cont1++;
    if (ristra1[cont1] != 'I') 
      return 0; 
    //Serial.write (ristra1[cont1]); 
    contador--; 
    cont1++;
    if (ristra1[cont1] != 'I') 
      return 0; 
    //Serial.write (ristra1[cont1]); 
    contador--; 
    cont1++;
    return 1;                                    // 1 => se ha detectado +RDII ... hay que suspender el envio de caracteres 
  }
  return 0;
}

