int wait_for_ROK()
{
  int inByte;                                      // Esperar a que llegue ROK cr lf 
  while (Serial3.available()== 0) {}               // Esperar a que llegue un caracter
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'R') 
    return -1;

  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'O') 
    return -1;

  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'K') 
    return -1;

  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 13) 
    return -1;                                       // ¿es carriage return?

  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 10) 
    return -1;                                      // ¿es line feed?
  return 0;                                         // el ROK ha llegado bien ...
}

int wait_for_OK()
{
  int inByte;                                       // Esperar a que llegue OK cr lf 
  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'O') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'K') 
  {
    //Serial.println(" ");
    return -1;
  }
  return 0;                                         // el OK ha llegado bien
}

/************************************************/
/* Devuelve 0 si se ha recibido +ROK            */
/* Devuelve -1 si NO se ha recibido +ROK        */
/* Devuelve 2 si se ha ha excedido el "tiempo"  */
/*  de espera en milisegundos                   */
/************************************************/

int wait_for_ROK_timeout(unsigned long tiempo)
{
  int inByte;
  unsigned long tiempo_actual, tiempo_base;
  tiempo_base = millis();                            // Esperar a que llegue ROK cr lf 
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                 // Esperar a que llegue un caracter (con timeout)
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'R') 
    return -1;
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                 // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'O') 
    return -1;
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                 // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'K') 
    return -1;
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                  // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 13) 
    return -1;                                       // ¿es carriage return?  
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                  // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 10) 
    return -1;                                       // ¿es line feed?
  return 0;                                          // el ROK ha llegado bien ...
}

/************************************************/
/* Devuelve 0 si se ha recibido +OK             */
/* Devuelve -1 si NO se ha recibido +OK         */
/* Devuelve 2 si se ha ha excedido el "tiempo"  */
/*  de espera en milisegundos                   */
/************************************************/

int wait_for_OK_timeout(unsigned long tiempo)
{
  int inByte;
  unsigned long tiempo_actual, tiempo_base;
  tiempo_base = millis();                             // Esperar a que llegue OK cr lf 
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                   // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'O') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                   // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'K') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                    // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();                             // ¿es carriage return?
  //Serial.write(inByte); 
  if (inByte != 13) 
  {
    //Serial.println(" ");
    return -1;
  }

  while (!Serial3.available()) 
  {
    tiempo_actual = millis();
    if (tiempo_actual - tiempo_base > tiempo) 
      return 2;
  }                                                     // Esperar a que llegue un caracter (con timeout);
  inByte = Serial3.read();                              // ¿es line feed?
  //Serial.write(inByte); 
  if (inByte != 10) 
  {
    //Serial.println(" ");
    return -1;
  }
  return 0;                                             // el OK ha llegado bien
}

int wait_for_SecureLinlEstablished()
{
  int inByte;                                          // Esperar a que llegue OK cr lf 
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != '+') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'R') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {
  }
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'S') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte);  
  if (inByte != 'L') 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {}
  inByte = Serial3.read();
  //Serial.write(inByte); 
  if (inByte != 'E') 
  {
    //Serial.println(" ");
    return -1;
  }
                                                  // Esperar a que llegue cr lf 
  while (!Serial3.available()) {}
  inByte = Serial3.read();                        // ¿es carriage return?
  //Serial.write(inByte); 
  if (inByte != 13) 
  {
    //Serial.println(" ");
    return -1;
  }
  while (!Serial3.available()) {}
  inByte = Serial3.read();                        // ¿es line feed?
  //Serial.write(inByte); 
  if (inByte != 10) 
  {
    //Serial.println(" ");
    return -1;
  }
  return 0;                                       // el +RSLE ha llegado bien
}

void vacia_buffer_serial()
{
  //Serial.print("<VBS0>");
  while (Serial.available()) 
  {
    int inByte = Serial.read();
    //Serial.write(inByte);                        // se imprime lo que se quita del buffer
  }
}

void vacia_buffer_serial3()
{
  //Serial.print("<VBS3>");
  while (Serial3.available()) 
  {
    int inByte = Serial3.read();
    //Serial.write(inByte);                       // se imprime lo que se quita del buffer
  }
}


